#!/bin/bash
## Indicamos el usuario con que queremos que inicie de manera automatica

USER=$(whoami)
ACTUAL=$(cat /etc/lightdm/lightdm.conf | grep autologin-user | cut -d "=" -f2)
TEXTO1="  Si lo deseas el equipo <b>iniciará Sesión Automáticamente</b>  \n   Selecciona la cuenta de usuario ..."
USERDEFINITIVO=""

function configurar-usuario-inicio-automatico-lightdm {

	USERDEFINITIVO="$1"
	if grep "autologin-user" /etc/lightdm/lightdm.conf ; then
		sed --follow-symlinks -i "s/.*autologin-user=.*/autologin-user=$1/g" /etc/lightdm/lightdm.conf
	else
		echo "autologin-user=$1" >> /etc/lightdm/lightdm.conf
	fi
}

function decidir-inicio-automatico {

	USUARIO=$(yad --center --width 500 \
	--window-icon=/usr/share/lxpanel/images/vitalinux.svg \
	--title "Inicio de Sesión Automático" \
	--text-align center \
	--image=/usr/share/lxpanel/images/usuario.png \
	--entry \
	--text "$TEXTO1" \
	--entry-text \
	"Sin-Inicio-Sesion-Automático" \
	$(awk -F ":" '{if ( $3 > 999 && $6~/\/home\/.*/) {print $1}}' /etc/passwd) \
	--button="gtk-ok:0" --button="gtk-cancel:1")

	if test $? -eq 1 ; then
		exit 0
	fi

	if test "$USUARIO" == "Usuario Nuevo a Crear" ; then
		crear-usuario
	else
		configurar-usuario-inicio-automatico-lightdm "$USUARIO"
	fi

	configurar-usuario-inicio-automatico-lightdm $NOMBRE
}

function crear-usuario {
TEXTO="  Se va a crear un usuario <b>Administrador</b> para trabajar con el equipo  \n\
   Ten en cuenta los siguientes aspectos:   \n\n\
   1.- El nombre del usuario no debe tener espacios en blanco \n\
   2.- No utilizes mayúsculas para el nombre \n\
   3.- Puedes usar números \n"
	DATOS=$(yad --center --width 400 \
	--window-icon=/usr/share/lxpanel/images/vitalinux.svg \
	--image=/usr/share/lxpanel/images/usuario.png \
	--title "Inicio de Sesión Automático" \
	--text-align center --justify="center" \
	--text "$TEXTO" \
	--form \
	--field="Nombre de Usuario" \
	--field="Password":H \
	--field="Repetir Password":H \
	--button="gtk-ok:0" --button="gtk-cancel:1")
	NOMBRE=$(echo $DATOS | cut -d"|" -f1)
	PASS=$(echo $DATOS | cut -d"|" -f2)
	REPPASS=$(echo $DATOS | cut -d"|" -f3)
	if ! grep "^$NOMBRE:" /etc/passwd && useradd -m -d /home/$NOMBRE \
		-s /bin/bash -p $(printf "$PASS" | mkpasswd -s -m md5) \
		-c "Usuario Creado para Inicio de Sesión Automática" $NOMBRE \
		&& test "$PASS" == "$REPPASS" ; then
		
		if yad --center --width 500 \
			--window-icon=/usr/share/lxpanel/images/vitalinux.svg \
			--title "Inicio de Sesión Automático" \
			--text-align center \
			--image=/usr/share/lxpanel/images/usuario.png \
			--text "   ¿¿Te gustaría que el usuario <b>$NOMBRE</b>   \n    fuera <b>administrador</b> del equipo??   " \
			--button="Si, <b>$NOMBRE</b> Administrador":0 --button="No":1 ; then
			if /usr/sbin/usermod -aG adm,cdrom,sudo,dip,plugdev,lpadmin,sambashare $NOMBRE ; then
				/usr/sbin/usermod -G "" $USER
				for ANTUSUARIO in $(awk -F ":" '{if ( $3 > 999 && $6~/\/home\/.*/) {print $1}}' /etc/passwd) ; do
					if test "$ANTUSUARIO" != "$USER" -a "$ANTUSUARIO" != "$NOMBRE" ; then
						/usr/sbin/userdel -fr $ANTUSUARIO
					fi
				done
			fi
			decidir-inicio-automatico
		fi
	else
		yad --center --width 500 \
		--window-icon=/usr/share/lxpanel/images/vitalinux.svg \
		--title "Inicio de Sesión Automático" \
		--text-align center \
		--image=/usr/share/lxpanel/images/usuario.png \
		--text "  ¡¡El usuario $NOMBRE ya existe!!  \n  o  \n  ¡¡Las Password no Coinciden!!  " \
		--button="Continuar":0
		crear-usuario
	fi
	
}

if [ -f $_FIRST ] ; then

	RESULTADO=$(yad --title "¡¡Bienvenid@ a Vitalinux EDU DGA!!" --center \
		--text "  ¡¡Bienvenid@ a <b>Vitalinux EDU DGA!!</b>  \n  En esta breve Post-Instalación deberás indicar en   \n  primer lugar el uso que vas a hacer del sistema:   " \
		--window-icon "/usr/share/pixmaps/curso/pdf.png" --image "/usr/share/pixmaps/curso/pdf.png" \
		--width=500 --height=200 \
		--list --radiolist  \
		--column Opcion:RD \
		--column Descripcion:TEXT \
		--column Numero:HD \
		TRUE "Voy a usar Vitalinux en un Centro Educativo" "1" \
		FALSE "Voy a usar Vitalinux en casa, o fuera de un centro Educativo" "2")
	OPCION=$(echo $RESULTADO | cut -d"|" -f3)
	case $OPCION in
		"1" ) # Sique el proceso normal de ejecución de scripts prern.d
			chmod u+rw,g+r,o+r /usr/share/migasfree-launcher/prerun.d/*.sh
		;;
		"2" )
			chmod -rx /usr/share/migasfree-launcher/prerun.d/01-confirmar_ip_cache.sh
			chmod -rx /usr/share/migasfree-launcher/prerun.d/02-usuario_inicio_sesion.sh
			crear-usuario
		;;
	esac

fi
